

.include 	"tn2313adef.inc"	;  tiny2313a


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;    SREG
.def	Temp5=R21
.def	Temp6=R22			; 
.def	Temp7=R23			; 
.def	Temp8=R24
.def	Temp9=R25





;******************************************************************************
; 
;******************************************************************************



.dseg					; 



ch_count: .byte 1			;   // 0,1,2 
					;  = 3,   
					;  = 4,   _


THR_len: .byte 2			;  2    =     ""


ruds_len: .byte 2			;  2    =     "ruds"





;******************************************************************************
; 
;******************************************************************************



.equ	MIDDLE_RUD_const = 0x200	; 512 =    (   )

.EQU	1000_const = 0x3E8 		; 1000

.EQU	Chastota=0x05FF 		;   1535 ( 1023+512 )


;******************************************************************************


.cseg

			

.org 0

rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset






.org PCI0addr				; External Interrupt Request 0

rjmp PCINT_00






;	.org ICP1addr				; = 0x0003 Timer/Counter1 Capture Event

;	rjmp ICP1_interruption




.org INT_VECTORS_SIZE


;******************************************************************************
;  ***********************************************************************
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;



	
	ldi Temp,0b11111111		;   "" (0-, 1-)
	out DDRB,Temp			; 
					 
		
	ldi Temp,0b00000000		;  _0
	out PortB,Temp			; 



		
												 
	ldi Temp,0b00111111		;   "D" (0-, 1-)
	out DDRD,Temp 			; 00xxxxxx -    
					; 0000000 -   



	ldi Temp,0b00000000		;  _0
	out PortD,Temp			;



;	RCALL	LCD_INIT		;  






;******************************************************************************
;   
;******************************************************************************

					;  _1

	ldi Temp,(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11)
	out TCCR1A,Temp					
					;  OC1A/OC1B  ,  OC1A/OC1B  .
					; 
 
					; COM1A1  /   OC1A // 
					; COM1A0  /   OC1A // 
					; COM1B1  /   OC1B // 
					; COM1B0  /   OC1B //  
					; WGM11=1 /  *
					; WGM10=0 /  *





	ldi Temp,(1<<cs11)|(1<<WGM13)|(1<<WGM12)	
	out TCCR1B,Temp					
					; Fast PWM    ICR1
					;


					;   = CK 1:8 (16/8=2) 1   = 0,5 
					;   !!!

					; ICNC1=0 /     ICP // 
					; ICES1=0 /    ICP   
					; WGM13=1 /  *
					; WGM12=1 /  *   ( Fast PWM )
					; CS12=0  /  
					; CS11=1  /   
					; CS10=0  /   = CK 1:8 (16/8=2) 1   = 0,5 



;	ldi Temp,0			; 
;	out TIMSK,Temp
					; TOIE1=0  /     _1 // 
					; OCIE1A=0 /  _A _1 //  
					; OCIE1B=0 /  _B _1 // 
					; ICIE=0   /    // 
					; OCIE0B=0 /  _B _0 // 
					; TOIE=0   /     _0 // 
					; OCIE0A=0 /  _A _0 // 





	LDI Temp,high(Chastota)		;    (    1535 )
	OUT ICR1H,Temp			;      
	LDI Temp,low(Chastota)							
	OUT ICR1L,Temp




	ldi Temp,(1<<ISC01)		;      "INT0" 
	out MCUCR,Temp




	ldi Temp,(1<<INT0)		;     INT0
	out GIMSK ,Temp













;******************************************************************************
;  
;******************************************************************************


	ldi Temp, 4			;   _
	sts ch_count, Temp







;******************************************************************************

	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp

	sei				;   
	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;   *********************************************************
;*******************************************************************************

PCINT_00:
	



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in XL,TCNT1L 			;    
	in XH,TCNT1H 			;    



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp


;**************************************************************************************************************
;   (     )
;**************************************************************************************************************



	LDS Temp, ch_count			;   


	cpi Temp, 4				;  _  ?
	brne work				;  ,  !!!!
	rjmp sinhro				;  ,  





;*********************************************************************************
;     13  ( 0b110010110010000 ) ( 0x6590 )
;*********************************************************************************

sinhro:

	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0x65			;     "Y" 13  0x6590
	ldi YL,0x90



	rcall compare_XY16		; ...

	breq bolshe			;     X=Y 
	brcs menshe			;     X<Y
	rjmp bolshe			;     X>Y 





;*****************************************************************************************
;   
;*****************************************************************************************


compare_XY16:

	cp Temp,YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            



;*****************************************************************************************
; ...
;*****************************************************************************************




bolshe:					;  ! 


	ldi Temp, 0			;   _,   0-  
	sts ch_count, Temp

	rjmp out_1			; 






menshe:					;    !

	rjmp out_1			; 








;*****************************************************************************************
;  ,  
;*****************************************************************************************


work:						;



channal_check_0:				;  _0


	LDS Temp, ch_count			;   


	cpi Temp, 0				;  0-  ?
	brne channal_check_1			; 
	rjmp channal_0				; 






channal_check_1:				;  _1


	LDS Temp, ch_count			;   


	cpi Temp, 1				;  1-  ?
	brne channal_check_2			; 
	rjmp channal_1				; 




channal_check_2:				;  _2


	LDS Temp, ch_count			;   


	cpi Temp, 2				;  2-  ?
	brne channal_check_sinhro		; 
	rjmp channal_2				; 





channal_check_sinhro:				;  (    ,  -  )

	

	ldi Temp, 0				;   _0
	sts ch_count, Temp



;   .. (  ... )
;
; ...
; ...


	rjmp out_1				; 


;*****************************************************************************************
;   
;*****************************************************************************************


channal_0:					; _0 (  )

	
	ldi Temp, 1				;   _1
	sts ch_count, Temp




	rcall calculation_of_ADC		;    THR   




	STS THR_len, XL				;    "THR_len"  THR
	STS THR_len+1, XH			; 


	rjmp out_1				; 





;**********************************************************************************************

channal_1:					; _1 (  )




	ldi Temp, 2				;   _2
	sts ch_count, Temp




	rcall calculation_of_ADC		;    RUD   




;    ;) ____________________________________________________________




; RUDS=RUD-MIDDLE_RUD

	ldi Temp, Low(MIDDLE_RUD)		;   512
	ldi Temp1, high(MIDDLE_RUD)


	SUB XL, Temp				;  RUDS (  RUD  MIDDLE_RUD )
	SBC XH, Temp1				;



	STS RUDS_len, XL			;    "RUDS_len"  RUDS
	STS RUDS_len+1, XH			; 



;    

	mov Temp, XH				;  XH  Temp

	andi Temp, 0b10000000			;  (  1,   ,  0,   )

	cpi Temp, 0b10000000			;    ?
	brne to_the_right			;  
	rjmp to_the_left			; 





;_______________________________________________________________________________________________
;_______________________________________________________________________________________________

to_the_right:					;   (   )

; 
; THR1=THR+RUDS
; THR2=THR-RUDS





	lds XL, RUDS_len			;   RUDS 
	lds XH, RUDS_len+1



;************************
;  THR1=THR+RUDS

	lds YL, THR_len				;   THR
	lds YH, THR_len+1	



	add YL, XL				; THR+RUDS
	adc YH, XH				;


;     (  "" )



	OUT OCR1AH, YH				;      						
	OUT OCR1AL, YL  








;************************
;  THR1=THR-RUDS

	lds YL, THR_len				;   THR
	lds YH, THR_len+1	



	SUB YL, XL				; THR-RUDS
	SBC YH, XH				;


;     (  "" )



	OUT OCR1BH, YH				;      						
	OUT OCR1BL, YL  









;_______________________________________________________________________________________________

to_the_left:					;   (   )

; 
; THR1=THR-RUDS
; THR2=THR+RUDS 


;      


; 0-(-RUDS)=RUDS

	ldi Temp, 0
	ldi Temp1, 0


	lds XL, RUDS_len			;   RUDS
	lds XH, RUDS_len+1



	SUB Temp, XL				;      
	SBC Temp1, XH				;   Temp  Temp1



	mov  XL, Temp				;            
	mov  XH, Temp1





;************************
;  THR1=THR-RUDS

	lds YL, THR_len				;   THR
	lds YH, THR_len+1	


	sub YL, XL				; THR-RUDS
	sbc YH, XH				;


;     (  "" )



	OUT OCR1AH, YH				;      						
	OUT OCR1AL, YL 









;************************
;  THR1=THR+RUDS

	lds YL, THR_len				;   THR
	lds YH, THR_len+1	


	add YL, XL				; THR+RUDS
	adc YH, XH				;


;     (  "" )



	OUT OCR1BH, YH				;      						
	OUT OCR1BL, YL  








;*****************************************************************************************************************
;        ( x/2-1000 )
;*****************************************************************************************************************

calculation_of_ADC:

; /2 (    )



	LSR XL					;    16-   (    )
	ROR XH					;


; -1000

	ldi Temp, Low(1000_const)
	ldi Temp1, high(1000_const)


	SUB XL, Temp				; -1000 
	SBC XH, Temp1				;

	ret					;   

;*****************************************************************************************************************





;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    


;**********************************************************************************************************************


.include "lcd5110mini.asm"		;   	




